<?php
/*
phpDIRList 2.0 - (c)2005 Ulrich S. Kapp :: Systemberatung :: web-programmierung
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list
of conditions and the following disclaimer.

Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

Neither the name of the Ulrich S. Kapp nor the names of its contributors may be
used to endorse or promote products derived from this software without specific
prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
|	dirLIST - PHP Directory Lister Version 0.2.0									|
|	Copyright  2008 Hamdiya														|
|	Support:hamdiya.dev@gmail.com


is a MAJOR MAJOR upgrade!!!!!!!!!!!!!!!!!!!!!

This file is a slight tweak of the version on the internet.
 - col 1 is wider.

*/
// -- Configuration -- //

// Table heading values
$file_name = "Filename";
$file_size = "Size in Bytes";
$file_date = "Last Modified";



// Page title, please edit only the string before '.str_replace ...'.
$title = "Index&nbsp;of&nbsp;".str_replace (substr (strrchr ($_SERVER["SCRIPT_NAME"] , "/"), 1), "", $_SERVER["SCRIPT_NAME"]);



$search_type = "exclude"; // include or exclude



/* If you configure '$search_type' to include, then phpDIRList 2.0 will
only show the files configured in the '$valid_files' array.

Caution: never change the first element of this array. */
$valid_files = array ("\\/", "pdf", "jpeg", "gif");



/* If you configure '$search_type' to exclude, then phpDIRList 2.0 will show
ALL files except the files configured in the '$invalid_files' array.

Caution: never change the first element of this array. */
$invalid_files = array ("\\/", "inc", "conf", "php");



/* '$show_hidden' decides if phpDIRList 2.0 shows hidden files.

Caution: if set to TRUE, phpDIRList 2.0 will show ALL secret files like
a .htaccess or .htpasswd file, if there is one in the folder. */
$show_hidden = FALSE; // TRUE or FALSE



// '$show_folders' tells phpDIRList 2.0 to show subdirectories.
$show_folders = TRUE; // TRUE or FALSE



// '$show_uplink' makes phpDIRList 2.0 to display the directory uplink.
$show_uplink = TRUE; // TRUE or FALSE



// '$show_executables' tells phpDIRList 2.0 to display executables.
$show_executables = FALSE; // TRUE or FALSE

// -- End Configuration -- //



function test_ext ($file) { // This is the function to check the validity of a directory entry.

	// Global all necessary variables
	global $valid_files;
	global $invalid_files;
	global $search_type;
	global $show_hidden;
	global $show_folders;
	global $show_uplink;
	global $show_executables;

	// Set initial value for '$create_entry'.
	if ($search_type == "exclude") {
		$create_entry = TRUE;
	} else $create_entry = FALSE;

	// Check if show_folder is set or else it is not a folder
	if (!$show_folders AND is_dir( $file)) {
		$create_entry = FALSE;
		if ($show_uplink AND preg_match("/^[\.]{1,2}$/", $file)) $create_entry = TRUE;
	} else if ($show_folders AND is_dir( $file)) {
		$create_entry = TRUE;
		if (!$show_uplink AND preg_match("/^[\.]{1,2}$/", $file)) $create_entry = FALSE;
	}

	// Check if show_folder is set or else it is not a folder
	if ($show_executables AND is_file($file) AND is_executable( $file)) {
		$create_entry = TRUE;
	} else if (!$show_executables AND is_file($file) AND is_executable( $file)) {
		$create_entry = FALSE;
	}

	// Check for valid or invalid file types.
	if ($search_type == "include") {
		if ($ext = substr (strrchr ($file, "."), 1)) {
			if (array_search ($ext, $valid_files)) $create_entry = TRUE;
		}
	} else if ($search_type == "exclude") {
		if ($ext = substr (strrchr ($file, "."), 1)) {
			if (array_search ($ext, $invalid_files)) $create_entry = FALSE;
		}
	}


	// At last check if show_hidden is set or else it is not a hidden file
	if (!$show_hidden AND preg_match("/^\./", $file)) {
		$create_entry = FALSE;
		if ($show_uplink AND preg_match("/^[\.]{1,2}$/", $file)) $create_entry = TRUE;
	} else if ($show_hidden AND preg_match("/^\./", $file)) {
		$create_entry = TRUE;
		if (!$show_uplink AND preg_match("/^[\.]{1,2}$/", $file)) $create_entry = FALSE;
	}

	// Finally return if an entry should be created or not.
	return ($create_entry);
}



// Try to get a directory handle and continue if it returns TRUE.
	if ($dir = @opendir("./")) {
	while (false !== ($filename = readdir($dir))) {$filesarray[] = $filename;}
	sort($filesarray);
	$output = ""; // Empty the HTML-output variable.
	    foreach($filesarray as $key => $file) {
		if (test_ext ($file)) { // Check if the entry should be displayed or not and continue if TRUE.
		// And append a table row to the output variable.
		$stats = @stat ( "./".$file);
		if (is_dir($file)) {$which = 'Dir';} else {$which = 'File';}
		if (!($file == "..")) {$fn = $file;} else {$fn = 'Parent Directory';}
		$output .= '
		<tr class="line">
			<td class="col1">'.$which.'</td>
			<td class="col2">
				<h2><a title="'.$file.'" href="'.$file.'">'.$fn.'</a></h2>
			</td>
			<td class="col3">'.number_format ($stats[7], 0, ",", ".").'</td>
			<td class="col4">'.str_replace (" ", "&nbsp;&middot;&nbsp;", date ("d.m.Y H:i", $stats[9])).'</td>
		</tr>'."\n";
		}
	}
	closedir($dir); // Close the directory handle.
} else {
	$output = "<tr><td colspan=\"3\"><h1>Cannot open Directory!</h1></td></tr>"; // Display error message if there was no directory handle returned in the leading condition.
}


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/2000/REC-xhtml1-20000126/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
	<head>
		<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
		<title><?php echo $title ?></title>
		<style type="text/css" media="screen">
	/* <![CDATA[ */
	h1 { font-family: Myriad Pro, Verdana, Geneva, Helvetica, Arial, Sans-Serif; font-size: small; padding: 0; margin: 0 }
	h2 { font-family: Myriad Pro, Verdana, Geneva, Helvetica, Arial, Sans-Serif; font-size: x-small; padding: 0; margin: 0 }
	p, a, div, td  { font-family: Myriad Pro, Verdana, Geneva, Helvetica, Arial, Sans-Serif; font-size: x-small }
	th {font-family: Myriad Pro, Verdana, Geneva, Helvetica, Arial, Sans-Serif; font-size: small; text-align: left }
	caption { font-family: Myriad Pro, Verdana, Geneva, Helvetica, Arial, Sans-Serif; font-size: medium; font-weight: bold; text-align: left; min-width: 28em; margin-bottom: 1em }
	address  { font-family: Myriad Pro, Verdana, Geneva, Helvetica, Arial, Sans-Serif; font-size: x-small }
	hr { width: 100%; height: 1px }
	.dirlist { min-width: 28em }
	.col1 { width: 02em; min-width: 02em; font-weight: bold; padding-right: 1em }
	.col2 { width: 45em; min-width: 25em; font-weight: bold; padding-right: 1em }
	.col3 { width: 10em; min-width: 7em; text-align: right; font-weight: bold; padding-right: 2em }
	.col4 { width: 10em; min-width: 7em; font-weight: bold }
	.subline { font-size: xx-small }
	.subline a { font-size: xx-small }
/* ]]> */
		</style>
	</head>
	<body>
		<table class="dirlist">
			<caption><?php echo $title; ?></caption>
			<tr>
				<th class="col1"><h1><?php echo Type; ?></h1></th>
				<th class="col2"><h1><?php echo $file_name; ?></h1></th>
				<th class="col3"><?php echo $file_size; ?></th>
				<th class="col4"><?php echo $file_date; ?></th>
			</tr>
			<tr><td colspan="4"><hr /></td></tr>
			<?php echo $output; /* This plops the whole bulk of the table, in html, into the html shell.  */ ?>
			<tr><td colspan="4"><hr /></td></tr>
		</table>
		<?php echo str_replace ("ADDRESS", "address", $_SERVER["SERVER_SIGNATURE"]); ?>
		<p class="subline">phpDIRList&nbsp;2.0&nbsp;&nbsp;-&nbsp;&nbsp;&copy;&nbsp;2005&nbsp;<a title="ulrich s. kapp :: systemberatung :: web-programmierung" href="http://www.ulrich-kapp.de/">ulrich s. kapp :: systemberatung :: web-programmierung</a>&nbsp;&nbsp;-&nbsp;&nbsp;<a href="http://validator.w3.org/check?uri=referer">W3C&nbsp;&rArr;&nbsp;XHTML 1.0 Strict</a>&nbsp;&nbsp;-&nbsp;&nbsp;<a href="http://jigsaw.w3.org/css-validator/check/referer">W3C&nbsp;&rArr;&nbsp;CSS</a></p>
	</body>
</html>
